<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package wheel_alignment_service
 */

function wheel_alignment_service_body_classes( $wheel_alignment_service_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$wheel_alignment_service_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$wheel_alignment_service_classes[] = 'no-sidebar';
	}

	$wheel_alignment_service_classes[] = wheel_alignment_service_sidebar_layout();

	return $wheel_alignment_service_classes;
}
add_filter( 'body_class', 'wheel_alignment_service_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function wheel_alignment_service_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'wheel_alignment_service_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function wheel_alignment_service_get_post_choices() {
	$wheel_alignment_service_choices = array( '' => esc_html__( '--Select--', 'wheel-alignment-service' ) );
	$wheel_alignment_service_args    = array( 'numberposts' => -1 );
	$wheel_alignment_service_posts   = get_posts( $wheel_alignment_service_args );

	foreach ( $wheel_alignment_service_posts as $wheel_alignment_service_post ) {
		$wheel_alignment_service_id             = $wheel_alignment_service_post->ID;
		$wheel_alignment_service_title          = $wheel_alignment_service_post->post_title;
		$wheel_alignment_service_choices[ $wheel_alignment_service_id ] = $wheel_alignment_service_title;
	}

	return $wheel_alignment_service_choices;
}
/**
 * Get all pages for customizer Page content type.
 */
function wheel_alignment_service_get_page_choices() {
	$wheel_alignment_service_choices = array( '' => esc_html__( '--Select--', 'wheel-alignment-service' ) );
	$wheel_alignment_service_pages   = get_pages();

	foreach ( $wheel_alignment_service_pages as $wheel_alignment_service_page ) {
		$wheel_alignment_service_choices[ $wheel_alignment_service_page->ID ] = $wheel_alignment_service_page->post_title;
	}

	return $wheel_alignment_service_choices;
}

if ( ! function_exists( 'wheel_alignment_service_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function wheel_alignment_service_excerpt_length( $wheel_alignment_service_length ) {
		if ( is_admin() ) {
			return $wheel_alignment_service_length;
		}

		return get_theme_mod( 'wheel_alignment_service_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'wheel_alignment_service_excerpt_length', 999 );

if ( ! function_exists( 'wheel_alignment_service_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function wheel_alignment_service_excerpt_more( $wheel_alignment_service_more ) {
		if ( is_admin() ) {
			return $wheel_alignment_service_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'wheel_alignment_service_excerpt_more' );

if ( ! function_exists( 'wheel_alignment_service_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function wheel_alignment_service_sidebar_layout() {
		$wheel_alignment_service_sidebar_position      = get_theme_mod( 'wheel_alignment_service_sidebar_position', 'right-sidebar' );
		$wheel_alignment_service_sidebar_position_post = get_theme_mod( 'wheel_alignment_service_post_sidebar_position', 'right-sidebar' );
		$wheel_alignment_service_sidebar_position_page = get_theme_mod( 'wheel_alignment_service_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$wheel_alignment_service_sidebar_position = $wheel_alignment_service_sidebar_position_post;
		} elseif ( is_page() ) {
			$wheel_alignment_service_sidebar_position = $wheel_alignment_service_sidebar_position_page;
		}

		return $wheel_alignment_service_sidebar_position;
	}
}

if ( ! function_exists( 'wheel_alignment_service_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function wheel_alignment_service_is_sidebar_enabled() {
		$wheel_alignment_service_sidebar_position      = get_theme_mod( 'wheel_alignment_service_sidebar_position', 'right-sidebar' );
		$wheel_alignment_service_sidebar_position_post = get_theme_mod( 'wheel_alignment_service_post_sidebar_position', 'right-sidebar' );
		$wheel_alignment_service_sidebar_position_page = get_theme_mod( 'wheel_alignment_service_page_sidebar_position', 'right-sidebar' );

		$wheel_alignment_service_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $wheel_alignment_service_sidebar_position ) {
				$wheel_alignment_service_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $wheel_alignment_service_sidebar_position || 'no-sidebar' === $wheel_alignment_service_sidebar_position_post ) {
				$wheel_alignment_service_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $wheel_alignment_service_sidebar_position || 'no-sidebar' === $wheel_alignment_service_sidebar_position_page ) {
				$wheel_alignment_service_sidebar_enabled = false;
			}
		}
		return $wheel_alignment_service_sidebar_enabled;
	}
}

if ( ! function_exists( 'wheel_alignment_service_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function wheel_alignment_service_get_homepage_sections() {
		$wheel_alignment_service_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'wheel-alignment-service' ),
			'vehicle-services' => esc_html__( 'Vehicle Services Section', 'wheel-alignment-service' ),
		);
		return $wheel_alignment_service_sections;
	}
}

/**
 * Renders customizer section link
 */
function wheel_alignment_service_section_link( $wheel_alignment_service_section_id ) {
	$wheel_alignment_service_section_name      = str_replace( 'wheel_alignment_service_', ' ', $wheel_alignment_service_section_id );
	$wheel_alignment_service_section_name      = str_replace( '_', ' ', $wheel_alignment_service_section_name );
	$wheel_alignment_service_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $wheel_alignment_service_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $wheel_alignment_service_starting_notation . $wheel_alignment_service_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function wheel_alignment_service_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'wheel_alignment_service_section_link_css' );

/**
 * Breadcrumb.
 */
function wheel_alignment_service_breadcrumb( $wheel_alignment_service_args = array() ) {
	if ( ! get_theme_mod( 'wheel_alignment_service_enable_breadcrumb', true ) ) {
		return;
	}

	$wheel_alignment_service_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $wheel_alignment_service_args );
}
add_action( 'wheel_alignment_service_breadcrumb', 'wheel_alignment_service_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function wheel_alignment_service_breadcrumb_trail_print_styles() {
	$wheel_alignment_service_breadcrumb_separator = get_theme_mod( 'wheel_alignment_service_breadcrumb_separator', '/' );

	$wheel_alignment_service_style = '
		.trail-items li::after {
			content: "' . $wheel_alignment_service_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$wheel_alignment_service_style = apply_filters( 'wheel_alignment_service_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $wheel_alignment_service_style ) ) );

	if ( $wheel_alignment_service_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $wheel_alignment_service_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'wheel_alignment_service_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function wheel_alignment_service_render_posts_pagination() {
	$wheel_alignment_service_is_pagination_enabled = get_theme_mod( 'wheel_alignment_service_enable_pagination', true );
	if ( $wheel_alignment_service_is_pagination_enabled ) {
		$wheel_alignment_service_pagination_type = get_theme_mod( 'wheel_alignment_service_pagination_type', 'default' );
		if ( 'default' === $wheel_alignment_service_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'wheel_alignment_service_posts_pagination', 'wheel_alignment_service_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function wheel_alignment_service_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'wheel_alignment_service_post_navigation', 'wheel_alignment_service_render_post_navigation' );

/**
 * Adds footer copyright text.
 */

function wheel_alignment_service_output_footer_copyright_content() {
    $wheel_alignment_service_theme_data = wp_get_theme();
    $wheel_alignment_service_copyright_text = get_theme_mod('wheel_alignment_service_footer_copyright_text');

	if (!empty($wheel_alignment_service_copyright_text)) {
        $wheel_alignment_service_text = $wheel_alignment_service_copyright_text;
    } else {

		$wheel_alignment_service_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/free-wheel-alignment-wordpress-theme','wheel-alignment-service')) . '" target="_blank"> ' . esc_html($wheel_alignment_service_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'wheel-alignment-service') . '&nbsp;<a target="_blank" href="' . esc_url($wheel_alignment_service_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($wheel_alignment_service_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $wheel_alignment_service_default_text .= sprintf(esc_html__(' | Powered by %s', 'wheel-alignment-service'), '<a href="' . esc_url(__('https://wordpress.org/', 'wheel-alignment-service')) . '" target="_blank">WordPress</a>. ');

        $wheel_alignment_service_text = $wheel_alignment_service_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($wheel_alignment_service_text); ?></span>
    <?php
}
add_action('wheel_alignment_service_footer_copyright', 'wheel_alignment_service_output_footer_copyright_content');

/* Footer Social Icons */ 
function wheel_alignment_service_footer_social_links() {

    if ( get_theme_mod('wheel_alignment_service_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('wheel_alignment_service_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('wheel_alignment_service_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('wheel_alignment_service_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'wheel-alignment-service'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('wheel_alignment_service_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('wheel_alignment_service_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('wheel_alignment_service_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'wheel-alignment-service'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('wheel_alignment_service_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('wheel_alignment_service_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('wheel_alignment_service_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'wheel-alignment-service'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('wheel_alignment_service_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('wheel_alignment_service_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('wheel_alignment_service_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'wheel-alignment-service'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('wheel_alignment_service_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('wheel_alignment_service_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('wheel_alignment_service_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'wheel-alignment-service'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'wheel_alignment_service_footer_social_links');

if ( ! function_exists( 'wheel_alignment_service_footer_widget' ) ) :
	function wheel_alignment_service_footer_widget() {
		$wheel_alignment_service_footer_widget_column = get_theme_mod('wheel_alignment_service_footer_widget_column','4');

		$wheel_alignment_service_column_class = '';
		if ($wheel_alignment_service_footer_widget_column == '1') {
			$wheel_alignment_service_column_class = 'one-column';
		} elseif ($wheel_alignment_service_footer_widget_column == '2') {
			$wheel_alignment_service_column_class = 'two-columns';
		} elseif ($wheel_alignment_service_footer_widget_column == '3') {
			$wheel_alignment_service_column_class = 'three-columns';
		} else {
			$wheel_alignment_service_column_class = 'four-columns';
		}
	
		if($wheel_alignment_service_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($wheel_alignment_service_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($wheel_alignment_service_i = 1; $wheel_alignment_service_i <= $wheel_alignment_service_footer_widget_column; $wheel_alignment_service_i++) {
					if (is_active_sidebar('wheel-alignment-service-footer-widget-' . $wheel_alignment_service_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($wheel_alignment_service_i = 1; $wheel_alignment_service_i <= $wheel_alignment_service_footer_widget_column; $wheel_alignment_service_i++) {
						if (is_active_sidebar('wheel-alignment-service-footer-widget-' . $wheel_alignment_service_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('wheel-alignment-service-footer-widget-' . $wheel_alignment_service_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'wheel-alignment-service'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'wheel-alignment-service'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'wheel-alignment-service'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'wheel-alignment-service'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="calendar-2" class="widget widget_calendar">
						<h2 class="widget-title"><?php esc_html_e('Calendar', 'wheel-alignment-service'); ?></h2>
						<?php get_calendar(); ?>
					</aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'wheel_alignment_service_footer_widget', 'wheel_alignment_service_footer_widget' );

function wheel_alignment_service_footer_text_transform_css() {
    $wheel_alignment_service_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($wheel_alignment_service_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'wheel_alignment_service_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

 function wheel_alignment_service_getpage_css($hook) {
	wp_enqueue_script( 'wheel-alignment-service-admin-script', get_template_directory_uri() . '/resource/js/wheel-alignment-service-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'wheel-alignment-service-admin-script', 'wheel_alignment_service_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'wheel-alignment-service-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'wheel_alignment_service_getpage_css' );

add_action('wp_ajax_wheel_alignment_service_dismissable_notice', 'wheel_alignment_service_dismissable_notice');
function wheel_alignment_service_switch_theme() {
    delete_user_meta(get_current_user_id(), 'wheel_alignment_service_dismissable_notice');
}
add_action('after_switch_theme', 'wheel_alignment_service_switch_theme');
function wheel_alignment_service_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'wheel_alignment_service_dismissable_notice', true);
    die();
}

function wheel_alignment_service_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'wheel-alignment-service-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'wheel_alignment_service_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Wheel Alignment Service', 'wheel-alignment-service'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Wheel Alignment Service journey to the next level.', 'wheel-alignment-service'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'wheel-alignment-service'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=wheel-alignment-service-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'wheel-alignment-service' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/wheel-alignment-service/"><?php esc_html_e('View Demo', 'wheel-alignment-service') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://asterthemes.com/products/alignment-services-wordpress-theme"><?php esc_html_e('Buy Now', 'wheel-alignment-service') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( WHEEL_ALIGNMENT_SERVICE_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'wheel-alignment-service') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}

add_action( 'admin_notices', 'wheel_alignment_service_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function wheel_alignment_service_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}